#!/bin/sh
# @1998 by Antonio GALLO - This is part of the Little Italy Linux distribution
# Version 1.005.1
# Mon Jun  4 12:50:37 2001 - build stage1.img for "Bad Penguin"
set -e


echo
echoc CYAN "[ Building stage1.img ]------------------------------------- "
echo


DISKSIZE=2000
DISKIMAGE=./bootdisk.img
MARGINE=5

echo "- makeing a filesystem image of ${DISKSIZE}Kb..."
rm -f $DISKIMAGE
dd if=/dev/zero of=$DISKIMAGE bs=1k count=$DISKSIZE 1>/dev/null
mke2fs -m0 -q $DISKIMAGE $DISKSIZE <<EOF 1>/dev/null
y
EOF

#echo "- mounting initrd via loopback image..."
set +e
umount /mnt/stage1 2>/dev/null
set -e
mkdir -p /mnt/stage1
mount -o loop -t ext2 $DISKIMAGE /mnt/stage1

#echo "- squeezing..."
squeeze . 1>/dev/null

#echo "- preparing and copying files..."
if [ ! -e ./dev/ram0 ]; then
  mknod ./dev/ram0 b 1 0
  chmod 440 ./dev/ram0
  chown root.disk ./dev/ram0
fi
if [ ! -e ./dev/initrd ]; then
  mknod ./dev/initrd b 1 250
  chmod 400 ./dev/initrd
  chown root.disk /dev/initrd
fi
if [ ! -e ./dev/loop0 ]; then
  mknod ./dev/loop0 b 7 0
  chmod 440 ./dev/loop0
  chown root.disk /dev/loop0
fi
if [ ! -e ./dev/console ]; then
  mknod ./dev/console c 5 1
  chmod 0666 ./dev/console
fi
for i in ./* ; do
  [ ! -d $i ] && continue
  echo "- copying $i..."
  cp -dpR $i  /mnt/stage1
done
if [ -x ../caronte/caronte ]; then
  echo "> we have a new 'caronte'"
  mv -f ../caronte/caronte ./linuxrc
  strip ./linuxrc
fi
if [ ! -x ./linuxrc ]; then
  echoc READ "! cannot continue without 'linuxrc'"
  exit 1
fi
cp -dp  ./linuxrc	/mnt/stage1

if [ -x ../modutils/insmod/insmod ]; then
  echo "> we have a new 'insmod'"
  mv -f ../modutils/insmod/insmod ./insmod
  strip ./insmod
fi
cp -dp  ./insmod	/mnt/stage1

echo "> syncing... (wait)"
sync

echo -n "! SPACE USED: "
du -k -l -s /mnt/stage1/
umount /mnt/stage1

echo "- compressing the filesystem image... (wait)"
gzip -f9 $DISKIMAGE

#echoc CYAN "[ Builing Boot Disk ]--------------------------------------"

#echo "Insert a floppy disk and press enter"
#read x


echo "- preparing a syslinux boot floppy..."
#mke2fs -q -m0 /dev/fd0 1440
gunzip -c ../tools/syslinux/img1440k.gz >/dev/fd0

#echo "- mounting ms-dos floppy..."
mount /dev/fd0 /floppy/ -t vfat

#echo "- copying syslinux.exe..."
cp -u ../tools/syslinux/syslinux.exe /floppy/
cp -u ./syslinux.cfg /floppy/
cp -u ./splash.msg   /floppy/

KERNELFILE=`ls -1 ../kernels/vmlinuz* | tail -1`
echo "! KERNEL FILE: $KERNELFILE"
echo "! KERNEL SIZE: `filesize $KERNELFILE`"
cp -u $KERNELFILE /floppy/vmlinuz
rdev -R /floppy/vmlinuz 1
rdev -v /floppy/vmlinuz -1
rdev -r /floppy/vmlinuz 0
#49152
rdev /floppy/vmlinuz /dev/fd0

IMAGEFILE=`ls -1 ./boot*gz | tail -1`
echo "!  IMAGE FILE: $IMAGEFILE"
echo "!  IMAGE SIZE: `filesize $IMAGEFILE`"
cp -u $IMAGEFILE  /floppy/initrd.gz

echo "- umounting and syncing... (wait)"
umount /floppy/
sync

echo
echo "                   Press enter to build the stage1.img file"
read x

echo "- creating the stage1 image from the floppy ..."
dd if=/dev/fd0 of=../../stage1.img
sync

echoc CYAN "done."
exit 0
