#!/bin/sh
# Sun Jul  1 09:54:11 2001 by AGX

. ansi.inc
TEMP1="/tmp/temp1"
TEMP2="/tmp/temp2"
TEMP3="/tmp/temp3"
rm -f "$TEMP1" "$TEMP2" "$TEMP3"

if [ "$1" = "" ]; then
  echoc RED "! no kernel was specified"
  sleep 2
  exit 2
fi
ROOTDEV="`cat /tmp/rootdev`"


# ===== Ask Kernel =====

while [ 0 ]; do

cat >$TEMP1 <<EOF
WINDOW|   13|  6|  54| 12| Scelta del Kernel
LABEL|    2|  2|| Please, choose how to install the
LABEL|    2|  3|| kernel: /boot/$1
LISTBOX|  2|  4| 50| 6| LIST1
LISTITEM| `echo $ROOTDEV|cut -b 1-3`     lilo on this MBR
LISTITEM| $ROOTDEV    lilo on this partition
LISTITEM| fd0     lilo onto a floppy
LISTITEM| floppy  make a rescue disk
BUTTON|   3| 10| 10| Install| BTOK
BUTTON|  29| 10| 10| Go back| BTCANCEL
EOF
cat $TEMP1 >/dev/tty2
gringosh -f "$TEMP1" -o "$TEMP2" 
if [ $? -ne 0 ]; then
  echoc RED "! gringosh error"
  sleep 2
  exit 2
fi

# Analyze
. $TEMP2
MODE="`echo $LIST1 | cut -f 1 -d' '`"

if [ "$BTCANCEL" = "1" ]; then
  exit 1
  
elif [ "$BTOK" = "1" ]; then

  TITLE "Installazione kernel"

  echoc CYAN "> setting $1 parameters with rdev"
  KFILE="/mnt/target/boot/$1"
  LFILE="/boot/$1"
  rdev -R  $KFILE  1
  rdev     $KFILE  /dev/$ROOTDEV
  rdev -r  $KFILE  0
  rdev -v  $KFILE  -3
  
  if [ "$MODE" != "floppy" ]; then

    echoc CYAN "> preparing LILO"
    TLILO="/tmp/lilo.conf"
    >$TLILO
    echo "default=badpenguin"	  >>$TLILO
    echo "message=/boot/message"	  >>$TLILO
    echo "timeout=3"		  >>$TLILO
    echo "prompt"                   >>$TLILO
    echo "image=$LFILE"    	  >>$TLILO
    echo "	label=badpenguin" >>$TLILO
    echo "	ramdisk=0"	  >>$TLILO
    echo "	root=/dev/$ROOTDEV"  >>$TLILO
    echo "	vga=extended"  	  >>$TLILO
    echo "	read-only"	  >>$TLILO
    echo "  	append=\"PROFILE=DEFAULT\"" >>$TLILO
    #
    echoc CYAN "> setting LILO"
    echo "boot=/dev/$MODE" >/mnt/target/etc/lilo.conf
    cat $TLILO >> /mnt/target/etc/lilo.conf
    mkdir -p /mnt/target/boot
    cp -f /boot/* /mnt/target/boot
    chmod 700 /mnt/target/etc/lilo.conf
    
    echoc CYAN "> running LILO"
    lilo -r /mnt/target -P ignore
    if [ $? -ne 0 ]; then
      echoc RED "! LILO error"
      sleep 2
      continue
    fi	
    echoc GREEN "- LILO floppy ready."
    echo "exec ./pivot_root.sh" >/tmp/ACTION
    exit 0
 
  else

    echo
    echoc PURPLE "        >>> INSERT AN EMPTY FLOPPY AND PRESS ENTER <<<"
    read x
    echo "> copying kernel to floppy"
    dd if=$KFILE of=/dev/fd0 bs=1k
    if [ $? -ne 0 ]; then
      echoc RED "! unable to copy the kernel"
      sleep 2
      continue
    fi	
    rdev /dev/fd0 /dev/$ROOTDEV
    sync
    echoc GREEN "- boot floppy ready."
    echo "exec ./pivot_root.sh" >/tmp/ACTION
    exit 0

  fi

fi

done
exit 2
