#!/bin/sh
# Sun Jul  1 09:54:11 2001 by AGX

TEMP1="/tmp/temp1"
TEMP2="/tmp/temp2"
TEMP3="/tmp/temp3"
TEMP4="/tmp/temp4"
rm -f "$TEMP1" "$TEMP2" "$TEMP3" "$TEMP4"

# Main Menu
while [ 0 ]; do

echoc CYAN "> parsing available partitions"
>$TEMP4
>$TEMP3
for i in /tmp/parted.*; do
  [ ! -f $i ] && continue
  DEVNAME=""
  DEVTYPE=""
  DEVSIZE=""
  DEVDESC=""
  DEVMKFS="no"
  DEVMNTP=""
  . $i
  if [ "$DEVMNTP" == "" ]; then
    echo "LISTITEM|$DEVNAME ($DEVTYPE) $DEVDESC  size:$DEVSIZE" >>$TEMP4
  else
    echo "LISTITEM|$DEVNAME ($DEVTYPE) mount:$DEVMNTP  format:$DEVMKFS  size:$DEVSIZE" >>$TEMP3
  fi
done


cat >$TEMP1 <<EOF
WINDOW|   2|  1|  76| 23| Partition Editor
LABEL|    2|  1|| You should have at least a root partition mounted under '/'
LABEL|    2|  3|| Partition in use:
LISTBOX|  2|  4| 72| 5| LIST1
`cat $TEMP3`

BUTTON|   3| 9| 15| Set mount point| BTMNT
BUTTON|  29| 9| 15| Toggle format| BTMKFS
BUTTON|  56| 9| 15| Set as unused| BTDEL

LABEL|    2| 11|| Unused partitions (scroll down for more):
LISTBOX|  2| 12| 72| 9| LIST2
`cat $TEMP4`
BUTTON|   3| 21| 15| Add mount point| BTADD
BUTTON|  38| 21| 15| Apply| BTOK
BUTTON|  56| 21| 15| Go back| BTCANCEL
EOF
cat $TEMP1 >/dev/tty2
gringosh -v -v -f "$TEMP1" -o "$TEMP2" 
if [ $? -ne 0 ]; then
  echoc RED "! gringosh error"
  echo "./target1.sh" >/tmp/ACTION
  sleep 2
  exit 2
fi

# Analyze
. $TEMP2
DEV1="`echo $LIST1 | cut -f 1 -d' '`"
DEV2="`echo $LIST2 | cut -f 1 -d' '`"

if [ "$BTMNT" = "1" ]; then
  ./parted-add.sh $DEV1

elif [ "$BTMKFS" = "1" ]; then
  echo "DEVMKFS=yes" >>/tmp/parted.$DEV1

elif [ "$BTDEL" = "1" ]; then
  echo "DEVMNTP=" >>/tmp/parted.$DEV1

elif [ "$BTADD" = "1" ]; then
  ./parted-add.sh $DEV2

elif [ "$BTCANCEL" = "1" ]; then
  echo "./target1.sh" >/tmp/ACTION
  exit 1

elif [ "$BTOK" = "1" ]; then
  echo "./target2.sh" >/tmp/ACTION
  exit 0
fi

done
exit 2
