#!/bin/sh

. ansi.inc
#TITLE "Preparazione partizioni"
TEMP1="/tmp/temp1"
TEMP2="/tmp/temp2"
rm -f "$TEMP1" "$TEMP2"

echoc PURPLE "well, ready for pivot_root??? press ENTER"
read x

# lo imposto ora... se ho problemi mi salva in calcio d'angolo :-P
echo "./mainmenu.sh" >/tmp/ACTION

echo "> umounting all target devices"

# Sort mount point
>$TEMP1
for i in /tmp/parted.*; do
  [ ! -f $i ] && continue
  . $i
  if [ "$DEVMNTP" != "" ]; then
    echo "$DEVNAME|$DEVTYPE|$DEVMNTP" >>$TEMP1
  fi
done
sort -t '|' -k 3 -r -o $TEMP2  $TEMP1

# Mount Root First
for i in `cat $TEMP2` ; do
  TEMPFILE="/tmp/parted.`echo $i | cut -d'|' -f1`"
  [ ! -f $TEMPFILE ] && continue
  . $TEMPFILE
  echoc GREEN "> un-mounting $DEVNAME ($DEVTYPE) under $DEVMNTP"
  umount /dev/$DEVNAME
  R=$?
  if [ $R -ne 0 ]; then
    echoc RED "! unable to umount $DEVNAME ($DEVTYPE) under $DEVMNTP"
    sleep 1
  fi
done

if [ 1 -eq 0 ]; then
echo "- mount new root device RO"
for i in /tmp/parted.* ; do
  [ ! -f $i ] && continue
  . $i
  [ "$DEVMNTP" != "/" ] && continue
  echoc GREEN "> mounting $DEVNAME ($DEVTYPE) under $DEVMNTP"
  mkdir -p /new-root
# TODO we use RW for now!!!
  mount /dev/$DEVNAME /new-root -t $DEVTYPE -o rw
  R=$?
  if [ $R -ne 0 ]; then
    echoc RED "! unable to mount $DEVNAME ($DEVTYPE) under $DEVMNTP"
    sleep 2
    exit 2
  fi
  break
done

echoc CYAN "> switching using pivot_root"
cd /new-root
mkdir initrd
pivot_root . initrd
echo "- PIVOT_ROOT return $?"

echoc CYAN "> running the new init"
exec chroot . sbin/init 3   <dev/console   >dev/console 2>&1
echo "!!! INIT DID NOT WORKED !!!" >/dev/tty2
echo "- chroot returned $?"

# TODO
# umount /initrd
# blockdev --flushbufs /dev/ram0    # /dev/rd/0 if using devfs
fi

MAJ=`ls -l  /dev/hda2 | cut -b 33-36`
echo "MAJ=$MAJ"
MIN=`ls -l  /dev/hda2 | cut -b 38-41`
echo "MIN=$MIN"
MDEV=$(( MAJ * 100 + MIN ))
echo "MDEV=$MDEV"
echo "0x$MDEV" >/proc/sys/kernel/real-root-dev
echo "exit 0" >/tmp/ACTION

echoc PURPLE "# $0 ultimato, premi ENTER"
read x

exit 3

