#!/bin/sh
# Sun Jul  1 09:54:11 2001 by AGX

TEMP1="/tmp/temp1"
TEMP2="/tmp/temp2"
TEMP3="/tmp/temp3"
TEMP4="/tmp/temp4"
rm -f "$TEMP1" "$TEMP2" "$TEMP3" "$TEMP4"
rm -fv /tmp/parted.*

echoc CYAN "> scanning available partitions"
>$TEMP1
IFS="|"
probepart | while read D1 D2 D3 D4; do
  DEVNAME="`echo $D1 | cut -b 6-`"
  TEMPFILE="/tmp/parted.$DEVNAME"
  echo "DEVNAME=$DEVNAME"   >$TEMPFILE
  echo "DEVTYPE=$D2" >>$TEMPFILE
  echo "DEVSIZE=$D3" >>$TEMPFILE
  echo "DEVDESC=\"$D4\""    >>$TEMPFILE
  echo "DEVMKFS=no"         >>$TEMPFILE
  echo "DEVMNTP="           >>$TEMPFILE
  # Listitem
  echo "LISTITEM|$DEVNAME ($D2) $D4  size:$D3" >>$TEMP3
done
IFS=" "


# ===== Ask Root Partition =====

while [ 0 ]; do

cat >$TEMP1 <<EOF
WINDOW|   2|  4|  76| 16| Root Partition
LABEL|    2|  2|| Please, choose wich will be your root partition:
LISTBOX|  2|  4| 72| 10| LIST1
`cat $TEMP3`
BUTTON|   3| 14| 15| Apply| BTOK
BUTTON|  56| 14| 15| Go back| BTCANCEL
EOF
cat $TEMP1 >/dev/tty2
gringosh -f "$TEMP1" -o "$TEMP2" 
if [ $? -ne 0 ]; then
  echoc RED "! gringosh error"
  sleep 2
  exit 2
fi

# Analyze
. $TEMP2
DEV1="`echo $LIST1 | cut -f 1 -d' '`"

if [ "$BTCANCEL" = "1" ]; then
  exit 1

elif [ "$BTOK" = "1" ]; then
  echo "DEVMNTP=/" >>/tmp/parted.$DEV1
  break
fi

done


# ===== Ask Format =====

while [ 0 ]; do

cat >$TEMP1 <<EOF
WINDOW|  15|  8|  50| 6| Format Partition
LABEL|    2|  2|| Do you wanna format the /dev/$DEV1 partition ?
BUTTON|   3|  4| 10| Yes| BTYES
BUTTON|  19|  4| 10|  No| BTNO
BUTTON|  34|  4| 10| Go back| BTCANCEL
EOF
cat $TEMP1 >/dev/tty2
gringosh -f "$TEMP1" -o "$TEMP2" 
if [ $? -ne 0 ]; then
  echoc RED "! gringosh error"
  sleep 2
  exit 2
fi

# Analyze
. $TEMP2

if [ "$BTCANCEL" = "1" ]; then
  echo "./cfdisk.sh" >/tmp/ACTION
  exit 1

elif [ "$BTYES" = "1" ]; then
  echo "DEVMKFS=yes" >>/tmp/parted.$DEV1
  break

elif [ "$BTNO" = "1" ]; then
  echo "DEVMKFS=no" >>/tmp/parted.$DEV1
  break

fi

done


# ===== Ask Parted =====

while [ 0 ]; do

cat >$TEMP1 <<EOF
WINDOW|  15|  8|  50| 6| Advanced Partition
LABEL|    2|  2|| Do you wanna add some other partition ?
BUTTON|   3|  4| 10| Yes| BTYES
BUTTON|  19|  4| 10|  No| BTNO
BUTTON|  34|  4| 10| Go back| BTCANCEL
EOF
cat $TEMP1 >/dev/tty2
gringosh -f "$TEMP1" -o "$TEMP2" 
if [ $? -ne 0 ]; then
  echoc RED "! gringosh error"
  sleep 2
  exit 2
fi

# Analyze
. $TEMP2

if [ "$BTCANCEL" = "1" ]; then
  echo "./cfdisk.sh" >/tmp/ACTION
  exit 1

elif [ "$BTYES" = "1" ]; then
  echoc CYAN "- launching parted.sh"
  echo "./parted.sh" >/tmp/ACTION
  exit 0
  
elif [ "$BTNO" = "1" ]; then
  echoc CYAN "- launching target2.sh"
  echo "./target2.sh" >/tmp/ACTION
  exit 0

fi

done
exit 2
